<template>
  <div class="service">
    <searchBox :btn-option-list="btnOptionList" @operateForm="operateForm"></searchBox>

    <div class="content-table">
      <ComTable
        :columns="columns"
        :table-data="tableData"
        @handlePagesizeChange="handlePagesizeChange"
        ref="comTable"
        :table-option="tableOption"
        :page-option="pageOption"
      >
        <template #is_open="record">
          <!-- 0:禁用; 1:启用 -->
          <a-tag :color="record.is_open == 0 ? 'red' : 'green'">{{
            record.is_open == 0 ? '禁用' : '启用'
          }}</a-tag>
        </template>

        <template #action="record">
          <OperateCom :record="record" :operate-list="operateList" @operateForm="operateForm" />
        </template>
      </ComTable>
    </div>
    <a-modal
      v-model:open="formModal"
      width="750px"
      style="top: 80px"
      :footer="null"
      :destroy-on-close="true"
    >
      <!-- action:edit add -->
      <EditCom
        :record="record"
        @operateForm="operateForm"
        type="serviceApi"
        :action="formStatus"
      ></EditCom>
    </a-modal>
  </div>
</template>

<script>
import { columnList, serviceApiOptions } from '../../../public/config/columnList'
import { getReq, postReq } from '@/request/api.js'
import EditCom from '@/components/EditCom.vue'
import { ExclamationCircleOutlined } from '@ant-design/icons-vue'
import { createVNode } from 'vue'

import searchBox from '@/components/SearchBox.vue'
export default {
  name: '',
  components: {
    searchBox,
    EditCom
  },
  props: {},
  data() {
    return {
      tableData: [],

      tableOption: {
        select: false
      },
      formModal: false,
      formState: {},
      formStatus: 'add', //表单状态辑状态 add:新增 edit:编辑
      pageOption: {
        pageSize: 10,
        page: 1
      },
      btnOptionList: [],
      paramsDate: {},
      workModeList: [
        {
          label: '最优经济化',
          value: 1
        },
        {
          label: '支撑电网稳定',
          value: 2
        },
        {
          label: '自定义',
          value: 3
        }
      ],
      policyList: [
        {
          label: '削峰套利',
          value: 1
        },
        {
          label: '需求响应',
          value: 2
        },
        {
          label: '自发自用',
          value: 3
        }
      ]
    }
  },
  computed: {},
  created() {
    let info = []
    let col = columnList.find((i) => i.page == 'serviceApi').columns
    if (col.length) {
      col.forEach((item) => {
        info.push(this.$setWidth(item))
      })
    }
    this.columns = info
  },

  mounted() {
    this.operateList = this.$getBtns(['查看', '修改', '删除'])
    this.btnOptionList = this.$getBtns(['新增'])
    this.getList()
  },

  methods: {
    async getList() {
      this.$refs.comTable.loading = true

      const { page, pageSize } = this.pageOption

      const params = {
        ...this.paramsDate,
        page_size: pageSize,
        page
      }

      try {
        const res = await getReq('/queryServiceApiList', params)
        if (res.errcode === 0) {
          this.$refs.comTable.loading = false

          this.tableData = res.data

          this.pageOption = {
            page: res.page,
            pageSize: res.page_size,
            count: res.count
          }
        } else {
          const err = { tip: res.errmsg }
          throw err
        }
      } catch (error) {
        //统一处理报错提示
        this.$refs.comTable.loading = false
      }
    },
    operateForm(type, record = {}) {
      this.formStatus = type
      switch (type) {
      case 'add':
        this.formModal = true
        this.formState = {}
        this.getRuleFormInfo()

        break
      case 'edit':
      case 'read':
        this.formModal = true
        this.formState = record
        this.getRuleFormInfo(record)
        break

      case 'del':
        this.handleDelete([record.api_id], this.getList)

        break

      case 'back':
        this.formModal = false
        this.getList()
        break

      default:
        break
      }
    },
    //  删除操作
    async handleDelete(id, callback) {
      const that = this
      this.$Modal.confirm({
        title: '你确认删除数据吗?',
        icon: createVNode(ExclamationCircleOutlined),

        async onOk() {
          try {
            const res = await getReq('/deleteServiceApi', { api_id: id })
            if (res.errcode === 0) {
              this.$message.success(res.errmsg)
              this.pageOption.page = 1
              callback()
            } else {
              throw res
            }
          } catch (error) {
            callback()
          }
        },
        onCancel() {},
        class: 'test'
      })
    },
    async getRuleFormInfo(record) {
      function getInfo(data, url) {
        return new Promise((reslove, reject) => {
          getReq(data, url).then((res) => {
            reslove(res.data)
          })
        })
      }

      let row = {}
      if (record && record.api_id) {
        // row = await getInfo({ api_id: record.api_id},'/queryserviceInfo')
        this.record = record
        row = record
        // this.type='edit'
      }
      serviceApiOptions.forEach((e, index) => {
        e.list.forEach((i) => {
          e.ruleForm[i.key] = row ? row[i.key] : ''
          e.ruleForm.id = row.id
        })
      })
    },
    handlePagesizeChange(pageOption) {
      this.pageOption.pageSize = pageOption.pageSize
      this.pageOption.page = pageOption.page
      this.getList()
    }
  }
}
</script>

<style lang="scss" scoped>
.service {
  height: 100%;
  padding:  20px;
  .content-table {
    height: calc(100% - 52px);
  }
}
</style>
